#include <R.h>
#include <Rmath.h>
#include <math.h>

double norm2(int     *p,
	     double x[*p],
	     double *norm) {
  
  for (int i=0; i<*p; i++) {
    *norm += pow(x[i],2);
  }
  *norm = sqrt(*norm);
}

double groupnorm(int     *p,
		 int    *K,
		 int    pk[*K],
		 double beta[*p],
		 double norm[*K]) {

  int ind=0;
  
  for (int k=0; k<*K; k++) {
    for (int i=0; i<pk[k]; i++) {
      norm[k] += pow(beta[ind],2);
      ind++;
    }
    norm[k] = sqrt(norm[k]);
  }
}

double groupnormrep(int   *p,
		    int    *K,
		    int    pk[*K],
		    double beta[*p],
		    double norm[*p]) {

  int ind=0, ind0;
  double normk;
  
  for (int k=0; k<*K; k++) {
    ind0=ind;
    normk=0;
    for (int i=0; i<pk[k]; i++) {
      normk += pow(beta[ind],2);
      ind++;
    }
    for (int j=ind0; j<(ind0+pk[k]); j++) {
      norm[j] = sqrt(normk);
    }
  }
}

double coopnorm(int     *p,
		int    *K,
		int    pk[*K],
		double beta[*p],
		double norm[*K]) {

  int ind=0;
  double norm_pos, norm_neg;

  for (int k=0; k<*K; k++) {
    norm_pos = 0;
    norm_neg = 0;
    for (int i=0; i<pk[k]; i++) {
      norm_pos += pow(fmax(0, beta[ind]),2);
      norm_neg += pow(fmax(0,-beta[ind]),2);
      ind++;
    }
    norm[k] = sqrt(norm_pos) + sqrt(norm_neg);
  }
}
